From 7c5c7bef34a9d09b0637b2e22015f7f8b79538e9 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 19 2020 21:41:01 +0000
Subject: [PATCH 1449/2232] Add ui test of async extern fn


---

diff --git a/tests/ui/async_fn.rs b/tests/ui/async_fn.rs
new file mode 100644
index 0000000..69f2642
--- /dev/null
+++ b/tests/ui/async_fn.rs
@@ -0,0 +1,10 @@
+#[cxx::bridge]
+mod ffi {
+    extern "Rust" {
+        async fn f();
+    }
+}
+
+async fn f() {}
+
+fn main() {}
diff --git a/tests/ui/async_fn.stderr b/tests/ui/async_fn.stderr
new file mode 100644
index 0000000..63e3666
--- /dev/null
+++ b/tests/ui/async_fn.stderr
@@ -0,0 +1,22 @@
+error[E0308]: mismatched types
+ --> $DIR/async_fn.rs:4:18
+  |
+4 |         async fn f();
+  |                  ^
+  |                  |
+  |                  expected `()`, found opaque type
+  |                  possibly return type missing here?
+...
+8 | async fn f() {}
+  |              - the `Output` of this `async fn`'s found opaque type
+  |
+  = note: expected unit type `()`
+           found opaque type `impl Future`
+help: consider `await`ing on the `Future`
+  |
+4 |         async fn f.await();
+  |                   ^^^^^^
+help: try adding a semicolon
+  |
+4 |         async fn f;();
+  |                   ^

